//+------------------------------------------------------------------+
//|                                            GoldWarrior02bMT4.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Nick Bilak"
#property link "www.forex-tsd.com"

//#include <Tracert.mqh>

extern int    Magic            = 98765;
extern double Lots             = 0.01;
extern double StopLoss         = 200;
extern double TakeProfit       = 500;
extern double TrailingStop     = 85;
extern int    BreakevenPips    = 85;      // Pips in profit to start the TrailingStop  
extern bool   Trace            = false;
extern int    per              = 21;      // Period for signal
extern int    drawShift        = 14;      // Forward shift
extern int    useMA            = 0;       // 1 = use MA
extern int    maPeriod         = 34;      // Moving average period
extern int    d                = 10;      // d - number of full periods when calculating 
extern int    Price            = 0;       // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern int    Length           = 100;     // Period of NonLagMA
extern double PctFilter        = 2;       // Dynamic filter in decimals
extern int    porog            = 300;     // porog - cut-off takeprofit when closing positions out 
extern int    test             = 1;       // test - current info output flag, 1 - output to journal 
extern int    imps             = 30;      // imps - positive impulse value for buy signal
extern int    impb             = 30;      // impb - negative impulse value for buy signal
extern int    k1               = 3;       // k1 & k2 - multiplier for sizes of hedge orders of 1st and 2nd level
extern int    k2               = 6;       // k2/k1=2 - must be!                                            
extern int    StartHour        = 0;       // Start Hour of Trade Session 
extern int    StartMinute      = 0;       // Start Minute of Trade Session 
extern int    EndHour          = 23;      // End Hour of Trade Session
extern int    EndMinute        = 0;       // End Hour of Trade Session
double LastTradeTime;
double ZZ2=0,ZZ3=0,cci0=0,cci1=0,nimp =0,summa=0;
double down=0,imp=0,mlot=0,ZZ0=0,ssum=0,bsum=0;
int cnt=0,j=0,ssig=0,bsig=0,b=0,bsb=0,sbo=0,bloks=0,blokb=0,pm=0,s=0,blok=1;
double myPoint;

int init()
{
myPoint = SetPoint(Symbol());  
   return(0);
}
 double SetPoint(string mySymbol)
  {
   double mPoint, myDigits;
   
   myDigits = MarketInfo (mySymbol, MODE_DIGITS);
   if (myDigits < 4)
      mPoint = 0.01;
   else
      mPoint = 0.0001;
   
   return(mPoint);
 }   

//---------------------------------------------------------------------------------------------------------------------//
// 
 
int start() { 

   if (j==10000) j=0;
   
   imp  = iCustom(NULL,0,"DayImplus1.1",per,drawShift,useMA,maPeriod,0,2);
   nimp = iCustom(NULL,0,"DayImplus1.1",per,drawShift,useMA,maPeriod,0,1);
   ZZ3  = iCustom(NULL,0,"nonlagzigzag_v2.1",Price,Length,PctFilter,0,2);
   ZZ2  = iCustom(NULL,0,"nonlagzigzag_v2.1",Price,Length,PctFilter,0,1);
   cci1 = iCCI(NULL,0,per,PRICE_CLOSE,2);
   cci0 = iCCI(NULL,0,per,PRICE_CLOSE,1);


   if 
   (
   (ZZ3!=0 || ZZ2!=0) 
   && 
   ((cci0 < cci1 && cci1 > 50 && cci0 > 30 && nimp < 0 && imp > 0)
   || 
   (cci0 > 200 && cci1 > cci0 && nimp > 100 && imp > nimp))
   )
   {
      ssig=1;
      if (!IsTesting()) 
      Comment("ZZ0=",NormalizeDouble(ZZ2,Digits)," ZZ1=",NormalizeDouble(ZZ3,Digits)," CCI0=",NormalizeDouble(cci1,Digits)," Impuls=",NormalizeDouble(nimp,Digits),
      "\n","If iZigZag line is up - sell now");
   }

   if 
   (
   (ZZ3!=0 || ZZ2!=0) 
   && 
   ((cci0 > cci1 && cci1 < -50 && cci0 < -30 && nimp > 0 && imp < 0)
   || 
   (cci0 < -200 && cci1 < cci0 && nimp < -100 && imp < nimp))
   )
   {
      bsig=1;
      if (!IsTesting()) 
      Comment("ZZ0=",NormalizeDouble(ZZ2,Digits)," ZZ1=",
      NormalizeDouble(ZZ3,Digits)," CCI0=",NormalizeDouble(cci1,Digits)," Impuls=",
      NormalizeDouble(imp,Digits),"\n","If iZigZag line is down - buy now");
   }

   if 
   (
   (ZZ2==0 && ZZ3==0) 
   || 
   sbo!=0 
   || 
   (imp>imps && imp<impb)
   ) 
   {
      ssig=0; //disallow sell
      bsig=0; //disallow buy
      if (!IsTesting()) 
      Comment("ZZ0=",NormalizeDouble(ZZ2,Digits)," ZZ1=",
      NormalizeDouble(ZZ3,Digits)," CCI0=",NormalizeDouble(cci1,Digits)," Impuls=",
      NormalizeDouble(imp,Digits),"\n"," Signals are absent");
   }

   sbo=0;s=0;b=0;summa=0;ssum=0;bsum=0;
   for (cnt=0; cnt<OrdersTotal(); cnt++) 
   {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
      {
         if (OrderSymbol()==Symbol()) 
         {
            sbo=sbo+1;//have open trades
            if (OrderType()==OP_SELL  || OrderType()==OP_BUY ) 
            summa=summa+OrderProfit();// profit of open trade
         
            if (OrderType()==OP_SELL)  
            {  
            s=s+1;//open trade is sell
            ssum=ssum+OrderProfit();//sell trade profit
            }
            if (OrderType()==OP_BUY )  
            { 
            b=b+1;//have open buy
            bsum=bsum+OrderProfit();//buy trade profit
            }
         }
      }
   }

   if (blok==0  && TimeCondition()) { //add to position and set hedge order of 1st level
      if (s==1 
            && summa>30 //add to position when profit > 30
            && cci0>150 
            && nimp>50 
            && imp>nimp)   {
         mlot=k1*Lots;
         int ticket=OrderSend(Symbol(),OP_SELL,mlot,Bid,3,Bid+StopLoss*myPoint,Bid-TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow);
         bsb=0; 
         blok=1; 
         return(0);
      }
      if (s==1 //set hedge 1st level for sell position
            && summa>0
            && cci0<-150 
            && nimp<-50 
            && imp<nimp ) {
         mlot=k1*Lots;
         ticket=OrderSend(Symbol(),OP_BUY,mlot,Ask,3,Ask-StopLoss*myPoint,Ask+TakeProfit*myPoint,"Sculp_BUY",Magic,0,Yellow);
         bsb=0; //allow open hedge 2nd level
         blok=1;
         return(0);
      } 
      if (s==1 //set hedge 1st level for sell position
            && summa<-30
            && cci0<-150
            && nimp<-50
            && imp<nimp ) {
         mlot=k1*Lots;
         ticket=OrderSend(Symbol(),OP_BUY,mlot,Ask,3,Ask-StopLoss*myPoint,Ask+TakeProfit*myPoint,"Sculp_BUY",Magic,0,Yellow);
         bsb=0; //allow open hedge 2nd level
         blok=1;
         return(0);
      } 
      // }
      if (b==1 //set hedge 1st level for buy position
            && summa<-30 
            && cci0>150 
            && nimp>50 
            && imp>nimp )    {
         mlot=k1*Lots;
         ticket=OrderSend(Symbol(),OP_SELL,mlot,Bid,3,Bid+StopLoss*myPoint,Bid-TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow);
         bsb=0; //alow 2nd lev hedge
         blok=1; //alow 2nd lev hedge
         return(0);
      }
      if (b==1 //add to buy position when profit > 30
            && summa>30 
            && cci0<-150 
            && nimp<-50 
            && imp<nimp ) {
         mlot=k1*Lots;
         ticket=OrderSend(Symbol(),OP_BUY,mlot,Ask,3,Ask-StopLoss*myPoint,Ask+TakeProfit*myPoint,"Sculp_BUY",Magic,0,Yellow);
         bsb=0;//alow 2nd lev hedge
         blok=1;//alow 2nd lev hedge
         return(0);
      }
      if (b==1 
            && summa>0 
            && cci0>150
            && nimp>50 
            && imp>nimp ) {
         mlot=k1*Lots;
         ticket=OrderSend(Symbol(),OP_SELL,mlot,Bid,3,Bid+StopLoss*myPoint,Bid-TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow);
         bsb=0;//alow 2nd lev hedge
         blok=1;//alow 2nd lev hedge
         return(0);
      }
   }
   if (blok==1 // set 2nd level hedge
         && (b+s)<=2 
         && summa<-2500  //current loss
         && bsb==0 && TimeCondition()) {   //allow open 2nd level hedge
      // set 2nd lev. hedge for buy pos.
      if ( ((b==1 && s==1) || b==2 || (b==1 && s==0)) && bsum<0 && bsum>ssum && cci0>150 && nimp>50) { 
         mlot=k2*Lots;
         ticket=OrderSend(Symbol(),OP_SELL,mlot,Bid,3,Bid+StopLoss*myPoint,Bid-TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow);
         bsb=1; 
         return(0);
      }
      if ( ((s==1 && b==1)  || s==2  || (s==1 && b==0)) && ssum<0 && bsum<ssum && cci0<-150 && nimp<-50)    {
         mlot=k2*Lots;
         ticket=OrderSend(Symbol(),OP_BUY,mlot,Ask,3,Ask-StopLoss*myPoint,Ask+TakeProfit*myPoint,"Sculp_BUY",Magic,0,Yellow); 
         bsb=1; 
         return(0);
      }
   }//*/
   if (sbo==0) { //do not have open trades
      bloks=0;//alow sell
      blokb=0;//allow buy
      pm=0; //disallow closing
      bsb=1;//disallow 2nd lev. hedge once more
   }//*/

   if (summa<0 && down>summa) 
      down=(MathRound(summa)); //loss


   if (test==1) { //print to log or screen
      
      if (j<=2) if (!IsTesting()) Comment(" ");
   } else  {
     
     }
     
   if (summa>porog) // profit margin
      pm=1;

   if (pm==1) { //close trades by profit
      for (cnt=0; cnt<OrdersTotal(); cnt++) {
         if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
               OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
               return(0);
            }
            if (OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) {
               OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
               return(0);
            }
         }
      } 
   }
   cnt=OrdersTotal();
   while(cnt>=0)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
	  {	     
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if ((OrderOpenPrice()-Ask)>=(TrailingStop*myPoint+BreakevenPips*myPoint)) 
				  {						
					 if (OrderStopLoss()>(Ask+myPoint*TrailingStop) || OrderStopLoss()==0)
					 {					
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+myPoint*TrailingStop,OrderClosePrice()-TakeProfit*myPoint-TrailingStop*myPoint,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if ((Bid-OrderOpenPrice())>=(TrailingStop*myPoint+BreakevenPips*myPoint)) 
				{
					if (OrderStopLoss()<(Bid-myPoint*TrailingStop)) 
					{
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-myPoint*TrailingStop,OrderClosePrice()+TakeProfit*myPoint+TrailingStop*myPoint,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
      cnt--;
   }

   if (sbo==0 && TimeCondition()) //have no open positions
         
      { 
      mlot=Lots; 
      if (ssig==1 && bloks==0) 
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*myPoint,Bid-TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow);
         blokb=1;//disallow second buy entry 
         bsb=1; //disallow second hedge of 2nd lev
         blok=0; //allow add position and hedge 1st lev.
         return(0);
      } 
      if (bsig==1 && blokb==0 && TimeCondition()) 
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*myPoint,Ask+TakeProfit*myPoint,"Sculp_Sell",Magic,0,Yellow); 
         bloks=1;//disallow second sell entry 
         bsb=1; //disallow second hedge of 2nd lev
         blok=0; //allow add position and hedge 1st lev.
         return(0);
      } 
   }
   return(0);
}

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;      
   else
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24)
          ||(TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
   return(result);
}   